var Rvk = {
	init: function() {
		this.toggleAction();
		// $('.mini_tabs_box').tabs();
		this.print();
		this.waterQualityPopup();
		this.externalLinks();
	},

	toggleAction: function () {

		$("h3.accordion").click(function() {
			var link = $(this);
			link.next().slideToggle(250);
			if (link.hasClass("accordion_opened")) {
				link.removeClass("accordion_opened").addClass("accordion_closed");
			} else {
				link.removeClass("accordion_closed").addClass("accordion_opened");
			}
			return false;
		});

	},

	print: function() {
		$('a.print').click(function() {
			window.print();
			return false;
		});
	},

	waterQualityPopup: function() {
		$('#two_column_right .water_quality a').click(function() {
			window.open(this.href);
			return false;
		});
	},

	externalLinks: function() {
		$("a[rel='external']").click(function() {
			window.open(this.href);
			return false;
		});
	},

	input: function(elem, defaultText, preventDefault) {
		elem = $(elem);
		var preventDefault = preventDefault == null ? 'blank' : preventDefault;
		var hintClass = 'input-hint';

		if (elem.length > 0) {
			var input = elem.get(0);

			// make sure we're dealing w/ an input field
			var tagName = input.tagName.toLowerCase();
			if ((tagName == 'input' && input.type == 'text') || (tagName == 'textarea')) {

				// load up the default text if nothing is in the field
				var val = $.trim(elem.val());
				if (val === '') {
					elem.val(defaultText);
					elem.addClass(hintClass);
				} else if (val == defaultText) {
					elem.addClass(hintClass);
				}

				// show our default text if there is nothing in the field
				elem.blur(function() {
					if ($.trim(this.value) === '') {
						this.value = defaultText;
						elem.addClass(hintClass);
					}
				});

				// hide our default text when input is clicked
				elem.focus(function() {
					if (this.value == defaultText) {
						this.value = '';
					}
					elem.removeClass(hintClass);
				});

				// prevent form from submitting when default value exists
				if (preventDefault === true || preventDefault == 'blank') {
					form = $(elem.get(0).form);
					if (form) {
						form.submit(function(event) {
							if ($.trim(elem.val()) == defaultText || $.trim(elem.val()) == "") {
								if (preventDefault === true) {
									event.preventDefault();
									elem.focus();
								} else {
									elem.val('');
								}
							}
							return true;
						});
					}
				}
			}
		}
	}

	/*
	,

	slideshow: function(element) {
		var timeout = null;
		var children = $(element).children();
		var size = children.length;
		var activeItem = $(children[0]);
		var fadeSpeed = 'slow';
		var delay = 2000;

		playShow();

		function nextItem() {
			clearTimeout(timeout);
			timeout = null;

			var activeIndex = children.index(activeItem);
			var nextIndex = nextItemIndex(activeIndex);
			nextItem = children.eq(nextIndex);

			activeItem.fadeOut(fadeSpeed);
			nextItem.fadeIn(fadeSpeed);

			activeItem = nextItem;

			playShow();
		}

		function nextItemIndex(activeIndex) {
			return size > activeIndex+1 ? activeIndex+1 : 0;
		}

		function playShow() {
			timeout = setTimeout(nextItem, delay);
		}
	}
	*/
};

Rvk.slideshow = {
	init: function(element) {
		this.timeout = null;
		this.children = $(element).children();
		this.size = this.children.length;
		this.activeItem = $(this.children[0]);
		this.fadeSpeed = 2000;
		this.delay = 7000;

		this.playShow();
	},

	playShow: function() {
		var slideshow = this;

		this.timeout = setTimeout(function() {
			slideshow.nextItem();
		}, this.delay);
	},

	nextItem: function() {
		clearTimeout(this.timeout);
		this.timeout = null;

		var activeIndex = this.children.index(this.activeItem);
		var nextIndex = this.nextItemIndex(activeIndex);
		var nextItem = this.children.eq(nextIndex);

		this.activeItem.fadeOut(this.fadeSpeed);
		nextItem.fadeIn(this.fadeSpeed);

		this.activeItem = nextItem;

		this.playShow();
	},

	nextItemIndex: function(activeIndex) {
		return this.size > activeIndex+1 ? activeIndex+1 : 0;
	}
};

Rvk.dropdown = {
	options: {
		title: '',
		disabled: false,
		ddClassName: 'dropdown'
	},

	init: function(element) {
		this.element = $(element);
		this.options.title = this.options.title || this.element.find('option.select-title').text();

		// this.element.addClass("ui-dropdown");

		// build the dropdown list
		this.list = Rvk.dropdown.buildList(this.element, this.options);
		this.element.after(this.list);

		// save original css values
		this.css = {
			position: this.element.css('position'),
			left: this.element.css('left')
		};

		// hide the select
		this.element.hide();

		if (this.element.attr('disabled')) {
			this.disable();
		} else {
			this.enable();
		}
	},

	enable: function() {
		var $this = this;

		this.options.disabled = false;

		// enable the form element and visual select
		this.element.removeAttr('disabled');
		this.list.find('.disabled').removeClass('disabled');

		var handle = this.list.find('dt a');

		// show the dropdown list when clicked
		handle.mousedown(function() {
			Rvk.dropdown.hideDropDowns();
			$this.list.find('.drop-dd').show();
			$(this).parent('.drop-dt').addClass('active');
			$('body').bind("mousedown", Rvk.dropdown.bodyClicked);
			return false;
		});

		return this.element;
	},

	buildList: function(element, options) {
		var select = element.get(0);
		var option = select.selectedIndex > -1 ? select[select.selectedIndex] : false;
		//tabindex = $(select).attr('tabindex');
		var selected = option ? option.text : '';

		// build drop down list
		var classNames = 'ui-dropdown ' + element.get(0).className;
		var ddList = '<dl class="' + classNames + '">';
		//ddList += tabindex ? ' tabindex="' + tabindex + '">' : '>';
		ddList += options.disabled ? '<dt class="drop-dt disabled">' : '<dt class="drop-dt">';
		ddList += '<a><em></em><span>' + selected + '</span></a></dt>';

		var ddClassName = options.ddClassName ? options.ddClassName + ' drop-dd ' : 'drop-dd ';

		ddList += '<dd style="display: none;" class="' + ddClassName + '">';
		ddList += '<div class="drop-hd"></div>';
		ddList += '<div class="drop-bd">';
		ddList += '<a class="close"></a>';

		if (options.title) {
			ddList += '<h3>' + options.title + '</h3>';
		}

		ddList += '</div>';
		ddList += '<div class="drop-ft"></div>';
		ddList += '</dd>';
		ddList += '</dl>';

		ddList = $(ddList);

		// bind event to the close icon
		ddList.find('.close').click(function() {
			Rvk.dropdown.hideDropDowns();
			return false;
		});

		// add select options
		var list = $('<ul class="drop-ul"></ul>');
		element.children('option:not(.select-title)').each(function(index){
			var linkText = $(this).text();
			var link = $('<a href="#">' + linkText + '</a>');

			var isSelected = element[0].options[element[0].selectedIndex].text == linkText;

			// change the selected list item
			link.click(function() {
				$('li', list).removeClass("selected");
				$(this).parent().addClass("selected");

				// only trigger if it's not selected already
				// need to pull in isSelected again since we're inside of the click event
				isSelected = element[0].options[element[0].selectedIndex].text == linkText;
				if (!isSelected) {
					ddList.find('.drop-dt a').html('<em></em><span>' + linkText + '</span>');
					element.find('option:not(.select-title)')[index].selected = true;

					Rvk.dropdown.hideDropDowns();

					// trigger change event so other code can hook into this
					element.trigger('change');
				} else {
					Rvk.dropdown.hideDropDowns();
				}

				return false;
			});

			var item = $('<li class="drop-li' + (isSelected ? ' selected' : '') + '"></li>').append(link);
			list.append(item);
		});

		ddList.find('.drop-bd').append(list);

		return ddList;
	},

	hideDropDowns: function(event) {
		$('dl.ui-dropdown .drop-dd').hide();
		$('dl.ui-dropdown .active').removeClass('active');
		$('body').unbind("mousedown", Rvk.dropdown.bodyClicked);

		return true;
	},

	bodyClicked: function(event) {
		var element = $(event.target);
		if (element.parents().is('.ui-dropdown')) {
			return false;
		}

		Rvk.dropdown.hideDropDowns();
	}

};

Rvk.uploads = {
	init: function(element, options) {
		element = $(element);

		options = options || {};
		options['max'] = options['max'] || 3;
		options['remove_text'] = options['remove_text'] || '[delete]';

		var fileList, input, currentInput, tagName;

		input = element.get(0);
		currentInput = element;
		tagName = input.tagName.toLowerCase();

		if (tagName == 'input' && input.type == 'file') {
			fileList = $('.file_list');
			element.after(fileList);

			options['name'] = element.attr('name');
			options['class'] = element.attr('class');
			options['size'] = element.attr('size');

			bindChange(element);
		}

		function createFile(fileInput) {
			fileInput.hide();
			var remove =  $('<li>' + fileInput.attr('value') + ' <a href="#">' + options['remove_text'] + '</a></li>');

			remove.find('a').click(function() {
				fileInput.remove();
				remove.remove();
				checkMax();
				return false;
			});

			fileList.append(remove);

			var file = $('<input type="file" name="' + options['name'] + '" class="' + options['class'] + '" size="' + options['size'] + '" />');
			fileInput.after(file);
			bindChange(file);
			currentInput = file;
			checkMax();
		}

		function bindChange(fileInput) {
			fileInput.change(function() {
				// IE 7 seems to trigger the change event when the field is hidden
				if (fileInput.is(':visible')) {
					createFile(fileInput);
				}
			});
		}

		function checkMax() {
			var length = fileList.children().length;

			if (options['max'] > 0 && length < options['max']) {
				currentInput.removeAttr('disabled');
			} else {
				currentInput.attr('disabled', 'disabled');
			}
		}

		// do an initial check in case files already exist
		$('.file_list a').click(function() {
			var link = $(this);
			fileList.after('<input type="hidden" name="file_remove[]" value="' + link.attr('data-id') + '" />');
			link.closest('li').remove();
			checkMax();
			return false;
		});

		// do an initial check in case files already exist
		checkMax();


		//
		// if
		//
		// $('#asdf').after('<div id="files_list" style="border:1px solid black;padding:5px;background:#fff;font-size:x-small;"><strong>Files (maximum '+fileMax+'):</strong></div>');
		// $("input.upload").change(function(){
		// doIt(this, fileMax);
		// });
		//
		// });
		//
		// function doIt(obj, fm) {
		// if($('input.upload').size() > fm) {alert('Max files is '+fm); obj.value='';return true;}
		// $(obj).hide();
		// $(obj).parent().prepend('<input type="file" class="upload" name="fileX[]" />').find("input").change(function() {doIt(this, fm)});
		// var v = obj.value;
		// if(v != '') {
		// $("div#files_list").append('<div>'+v+'<input type="button" class="remove" value="Delete" /></div>')
		// .find("input").click(function(){
		// $(this).parent().remove();
		// $(obj).remove();
		// return true;
		// });
		// }
		//
		// };
	}
};

Rvk.googleMap = null;

Rvk.waterQualityMap = function() {
	var r = this;
	
	var latlng = new google.maps.LatLng(40.784920, -74.000660);

	var myOptions = {
		zoom: 11,
		center: latlng,
		// disableDefaultUI: true,
		// disableDoubleClickZoom: true,
		// draggable: false,
		// keyboardShortcuts: false,
		// scrollwheel: false,
		mapTypeControl: true,
		mapTypeId: google.maps.MapTypeId.TERRAIN
	};
	
	r.googleMap = new google.maps.Map(document.getElementById("map_canvas"), myOptions);	
	
	// var contentString = '<div class="loc-info" style="height: 120px;">';
	// contentString += '<h4>Albany Rowing Dock</h4>';
	// contentString += '<p>Last Tested: 07.09.09 <br />';
	// contentString += 'Samples Taken: 12</p>';
	// contentString += '<p><a href="#" class="more">View Riverkeeper Data</a><br />';
	// contentString += '<a href="#" class="more">View Queens College Data</a></p>';
	// contentString += '</div>';
	
	var contentString = '<div class="loc-info" style="height: 120px;">';
	contentString += '<h4>East River at<br>Roosevelt Island</h4>';
	contentString += '<dl>';
	contentString += '<dt>Last tested:</dt>';
	contentString += '<dd>07.09.09</dd>';
	contentString += '<dt>Samples Taken:</dt>';
	contentString += '<dd>12</dd>';
	contentString += '</dl>';
	contentString += '<ul><li><a href="#0.1.1_">View Riverkeeper Data <img src="/wp-content/themes/rvk/images/common/arrow_next_over.png" border="0" width="6" height="5" alt="arrow"></a></li><li><a href="#0.1.1_">View Queens College Data <img src="/wp-content/themes/rvk/images/common/arrow_next_over.png" border="0" width="6" height="5" alt="arrow"></a></li></ul>';
	contentString += '</div>';
	
	var infowindow = new google.maps.InfoWindow({
		content: contentString
	});

	var marker = new google.maps.Marker({
		position: latlng,
		map: r.googleMap,
		title: 'Albany Rowing Dock'
	});
	
	google.maps.event.addListener(marker, 'click', function() {
		infowindow.open(r.googleMap, marker);
	});
	
	
	// console.log(Rvk.googleMap.getCenter());
};


// IE6 specific javascript
if ($.browser.msie && parseInt($.browser.version) < 7 && !window.XMLHttpRequest) {
	ieHover = function() {
		var ieEls = document.getElementById("site_nav_level_1").getElementsByTagName("li");
		for (var i=0; i<ieEls.length; i++) {
			ieEls[i].onmouseover=function() {
				this.className+=" ie_hover";
			};
			ieEls[i].onmouseout=function() {
				this.className=this.className.replace(new RegExp(" ie_hover\\b"), "");
			};
		}
	};
	if (window.attachEvent) { window.attachEvent("onload", ieHover); }
}


function elink1(s1) {
	var s2 = 'riverkeeper.org';
	var s3 = 'mail'+'to:';
	var s4 = s1+'@'+s2;
	var s5 = '<a href="'+s3+s4+'">'+s4+'</a>';
	document.write(s5);
}

function elink2(s3,s2,s1,s8) {
	var s5 = 'mail'+'to:';
	var s6 = s1+'@'+s2+"."+s3;
	var s7 = '<a href="'+s5+s6+'">'+s8+'</a>';
	document.write(s7);
}

function elink3(s3,s2,s1) {
	var s4 = s1+'@'+s2+"."+s3;
	document.write(s4);
}

Rvk.waterQualityTestingMap = {
	init: function() {
		this.highlightTestingLocation();
	},

	highlightTestingLocation: function() {
		$("#wqt_map_locations_box ul li h3 a").click(function() {
			var elmt = $(this);
			var parent = elmt.parent();

			if (parent.hasClass("accordion_opened")) {
				parent.removeClass("accordion_opened").addClass("accordion_closed");
			} else {
				parent.removeClass("accordion_closed").addClass("accordion_opened");
			}

			for (var i=1; i<=6; i++) {
				var elRef = "a.loc"+i;
				$(elRef).parent().next().slideUp(250);
				$(elRef).parent().removeClass("accordion_opened").addClass("accordion_closed");
			}

			parent.next().slideDown(250);
			parent.removeClass("accordion_closed").addClass("accordion_opened");

			var elAttr = elmt.attr("class");
			switch (elAttr) {
				case "loc1":
					thisMovie("wqt_map").callFunc1();
					break;
				case "loc2":
					thisMovie("wqt_map").callFunc2();
					break;
				case "loc3":
					thisMovie("wqt_map").callFunc3();
					break;
				case "loc4":
					thisMovie("wqt_map").callFunc4();
					break;
				case "loc5":
					thisMovie("wqt_map").callFunc5();
					break;
				case "loc6":
					thisMovie("wqt_map").callFunc6();
					break;
			}

			return false;
		});
	},

	selectTestingLocationGroup: function(groupId) {
		for (var i=1; i<=6; i++) {
			var className = "a.loc"+i;
			var elmt = $(className).parent();
			if (i == groupId) {
				elmt.next().slideDown(250);
				elmt.removeClass("accordion_closed").addClass("accordion_opened");

			} else {
				elmt.next().slideUp(250);
				elmt.removeClass("accordion_opened").addClass("accordion_closed");
			}
		}

	}

};

function thisMovie(movieName) {
    if (navigator.appName.indexOf("Microsoft") != -1) {
        return window[movieName];
    } else {
        return document[movieName];
    }
}

var browser=navigator.appName;
var browser_version=navigator.appVersion;
var version=parseFloat(browser_version);

var theSansFont = {
src: '/wp-content/themes/rvk/flash/theSansFont.swf'
,ratios:
[9, 1.27, 14, 1.19, 21, 1.16, 28, 1.13, 38, 1.12, 53, 1.11, 60, 1.1, 61, 1.11, 94, 1.1, 96, 1.09, 101, 1.1, 102, 1.09, 103, 1.1, 108, 1.09, 110, 1.1, 1.09]
};

// sIFR.domains = ['riverkeeper.org']
sIFR.useStyleCheck = true;
sIFR.activate(theSansFont);

if (browser.indexOf('Opera') > -1) {
// } else if (browser_version.indexOf('Safari') > -1) {
} else {

	sIFR.replace(theSansFont, {
	selector: '.widget dl.stats dd'
	,wmode: 'transparent'
	,fitExactly: true
	,css: [
		'.sIFR-root { text-align: left; color: #3f6c89; font-weight: normal; font-size: 24px; width: 100%; }'
	]
	});
	sIFR.replace(theSansFont, {
	selector: '.widget .event_name a'
	,wmode: 'transparent'
	,fitExactly: true
	,selectable: false
	,css: [
		'.sIFR-root { text-align: left; color: #3f6c89; font-weight: normal; font-size: 26px; width: 100%; cursor: pointer; leading: -5; text-transform: lowercase; letter-spacing: -1; }'
	]
	});
	sIFR.replace(theSansFont, {
	selector: '.widget .event_name a:hover'
	,wmode: 'transparent'
	,fitExactly: true
	,selectable: false
	,css: [
		'.sIFR-root { text-align: left; color: #e8760b; font-weight: normal; font-size: 24px; width: 100%; cursor: pointer; leading: -5; }'
	]
	});
	sIFR.replace(theSansFont, {
	selector: '.widget .event_date a'
	,wmode: 'transparent'
	,fitExactly: true
	,selectable: false
	,css: [
		'.sIFR-root { text-align: left; color: #3f6c89; font-weight: normal; font-size: 14px; width: 200px; cursor: pointer; leading: -5;text-transform: lowercase; }'
	]
	});
	sIFR.replace(theSansFont, {
	selector: '.widget .why_we_care'
	,wmode: 'transparent'
	,fitExactly: true
	,selectable: false
	,css: [
		'.sIFR-root { text-align: left; color: #3f6c89; font-weight: normal; font-size: 20px; width: 100%; leading: -5;text-transform: lowercase; letter-spacing: -1; }'
	]
	});
	/*
	sIFR.debug.ratios({ src: '/wp-content/themes/rvk/flash/theSansFont.swf', selector: '.widget dl.stats dd' });
	*/

}
